/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.macd.test;

import com.macd.test.messagerouter.MessageRouterException;
import com.macd.test.messagerouter.MessageRouterInterface;
import com.macd.test.messagerouter.MessageRouterLocal;
import javax.ejb.EJB;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.jms.DeliveryMode;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;

/**
 *
 * @author joerg
 */
//@TransactionAttribute(TransactionAttributeType.NOT_SUPPORTED)
//@TransactionManagement(TransactionManagementType.CONTAINER)
public class MessageProcessor01Bean implements MessageListener {

    private final Logger logger = new Logger(MessageProcessor01Bean.class, "" + this.hashCode());
    @EJB(name = MessageRouterInterface.LOCAL_REFERENCE_NAME,
    beanInterface = MessageRouterLocal.class)
    private MessageRouterInterface messageRouter;

    public MessageProcessor01Bean() {
    }

    public void onMessage(Message message) {
        final ObjectMessage objectMessage = (ObjectMessage) message;
        try {
            logger.logInfo("got Message: " + objectMessage.getObject());
            logger.logInfo("Sending a message to external process");
            for (int i = 0; i < 10; i++) {
                messageRouter.sendMessage("MessageFromMessageProcessor01-" + i, "MessageProcessor02", DeliveryMode.NON_PERSISTENT);
            }
        } catch (MessageRouterException ex) {
            logger.logError(ex.getMessage(), ex);
        } catch (JMSException ex) {
            logger.logError(ex.getMessage(), ex);
        }
    }
}
