package com.macd.test.messagerouter;

import javax.jms.Message;

/**
 *
 * <br>
 *
 * @version <small>
 *
 *          <pre>
 *    SVN: repository            $URL: svn+ssh://svnserver/Macd-SVN-Repository/all-macd/branches/ALL_MACD_7_7_2_branch/src/com/macd/xConnect/ejbeans/messagerouter/MessageRouterInterface.java $
 *    SVN: last committed   $Revision: 5740 $
 *    SVN: last committed       $Date: 2009-07-24 14:53:58 +0200 (Fri, 24 Jul 2009) $
 *    SVN: last committed     $Author: joerg $
 *  &lt;/small&gt;
 * </pre>
 *
 * @author (C) Macdonald Associates Ltd. All Rights Reserved.
 *
 */
public interface MessageRouterInterface {

    public final static String GLOBAL_JNDI_NAME = "ejb/MessageRouterBean";
    public final static String LOCAL_REFERENCE_NAME = "MessageRouterBean";

    /**
     * Routes the given message based on target address
     *
     * @param myAddress
     *            The sender address. Used to avoid sending messages to itself.
     * @param applicationMessage
     *            Message to route
     * @param deliveryMode
     *            JMS delivery mode
     * @throws MessageRouterException
     *             If the message could not be routed to its target address
     */
    public void routeMessage(String myAddress,
            Object message,
            int deliveryMode)
            throws MessageRouterException;

    /**
     * Sends the given message directly to the given target address.
     *
     * @param applicationMessage
     *            The message to send
     * @param targetAddress
     *            Target address for message
     * @param deliveryMode
     *            JMS delivery mode
     * @throws MessageRouterException
     *             If the message could not be send to its target address
     */
    public void sendMessage(Object applicationMessage,
            String targetAddress,
            int deliveryMode)
            throws MessageRouterException;
}
