


package com.macd.test.messagerouter;

import javax.naming.InitialContext;
import javax.naming.NamingException;



/**
 *
 *  <br>
 *  @version <small><pre>
 *    SVN: repository            $URL: svn+ssh://svnserver/Macd-SVN-Repository/all-macd/branches/ALL_MACD_7_7_2_branch/src/com/macd/xConnect/ejbeans/messagerouter/MessageRouterUtility.java $
 *    SVN: last committed   $Revision: 4896 $
 *    SVN: last committed       $Date: 2009-04-22 16:55:39 +0200 (Wed, 22 Apr 2009) $
 *    SVN: last committed     $Author: reiner $
 *  </small></pre>
 *
 *  @author (C) Macdonald Associates Ltd. All Rights Reserved.
 *
 */
public class MessageRouterUtility {



    public final static MessageRouterInterface getManagerLocal() {
        try {
            InitialContext context = new InitialContext();
            return (MessageRouterInterface)context.lookup( "java:comp/env/" + MessageRouterInterface.LOCAL_REFERENCE_NAME );

        } catch ( NamingException e ) {
            throw new IllegalStateException( "Failed to lookup the MessageRouterManager: " + e.getMessage(), e );
        }
    }



    public final static MessageRouterInterface getManagerRemote() {
        try {
            InitialContext context = new InitialContext();
            return (MessageRouterInterface)context.lookup( MessageRouterInterface.GLOBAL_JNDI_NAME );

        } catch ( NamingException e ) {
            throw new IllegalStateException( "Failed to lookup the MessageRouterManager: " + e.getMessage(), e );
        }
    }



    public final static MessageRouterInterface getManager( boolean useLocalInterfaces ) {

        if ( useLocalInterfaces ) {
            return getManagerLocal();
        } else {
            return getManagerRemote();
        }
    }



}
